import * as schemaFiles from "../models/schemaFiles.models";
import { Summary } from "../helpers/objects";
export interface IEntity {
    name: string;
    database: string;
}
export declare abstract class Entity<T extends schemaFiles.SchemaEntityTypes> implements IEntity {
    name: string;
    database: string;
    constructor(name?: string, database?: string, entity?: T | string);
    protected abstract parseCreate(create: string): Summary;
    protected abstract parseJSON(object: T): Summary;
    protected onParseError(e: Error, offendingObjectName: string, entityTypeName: string): Summary;
    abstract clear(): Entity<T>;
    abstract asCreate(): string;
    abstract asJSON(): T;
}
