import * as sqliteModels from "../../models/sqlite.models";
import * as helperObjects from "../../helpers/objects";
export declare abstract class Constraint {
    name: string;
    columns: string[];
    constructor(name: string, columns?: string[]);
    validate(): helperObjects.Summary;
}
export interface IConflictableConstraint {
    onConflict?: sqliteModels.ConstraintConflictResolution;
}
export declare class PKConstraint extends Constraint implements IConflictableConstraint {
    autoIncrement: boolean;
    order: sqliteModels.Order;
    onConflict: sqliteModels.ConstraintConflictResolution;
    constructor(name: string, columns?: string[], autoIncrement?: boolean, order?: sqliteModels.Order, onConflict?: sqliteModels.ConstraintConflictResolution);
    validate(): helperObjects.Summary;
}
export declare class FKConstraint extends Constraint {
    parentTable: string;
    parentColumn: string;
    constructor(name: string, columns?: string[], parentTable?: string, parentColumn?: string);
    validate(): helperObjects.Summary;
}
export declare class NotNullConstraint extends Constraint implements IConflictableConstraint {
    onConflict: sqliteModels.ConstraintConflictResolution;
    constructor(name: string, columns?: string[], onConflict?: sqliteModels.ConstraintConflictResolution);
    validate(): helperObjects.Summary;
}
export declare class UniqueConstraint extends Constraint implements IConflictableConstraint {
    onConflict: sqliteModels.ConstraintConflictResolution;
    constructor(name: string, columns?: string[], onConflict?: sqliteModels.ConstraintConflictResolution);
    validate(): helperObjects.Summary;
}
export declare class CheckConstraint extends Constraint implements IConflictableConstraint {
    checkExpression: string;
    onConflict: sqliteModels.ConstraintConflictResolution;
    constructor(name: string, columns?: string[], checkExpression?: string, onConflict?: sqliteModels.ConstraintConflictResolution);
    validate(): helperObjects.Summary;
}
export declare class DefaultConstraint extends Constraint implements IConflictableConstraint {
    value: string | number;
    onConflict: sqliteModels.ConstraintConflictResolution;
    constructor(name: string, columns?: string[], value?: string | number, onConflict?: sqliteModels.ConstraintConflictResolution);
    validate(): helperObjects.Summary;
}
