export declare class Summary {
    errorMessages: string[];
    warningMessages: string[];
    infoMessages: string[];
    constructor(errorMessages?: string[], warningMessages?: string[], infoMessages?: string[]);
    /**
     * Append the passed summary to this summary.
     * @param summary The summary to append to this.
     */
    append(summary: Summary): Summary;
    /**
     * Returns a new summary that is the concatenation of this and the passed summary.
     * @param summary The additional summary
     */
    concat(summary: Summary): Summary;
}
export declare class ResultSummary<resultType> {
    data: resultType;
    summary: Summary;
    constructor(data?: resultType, summary?: Summary);
}
