"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Summary = (function () {
    function Summary(errorMessages, warningMessages, infoMessages) {
        if (errorMessages === void 0) { errorMessages = []; }
        if (warningMessages === void 0) { warningMessages = []; }
        if (infoMessages === void 0) { infoMessages = []; }
        this.errorMessages = errorMessages;
        this.warningMessages = warningMessages;
        this.infoMessages = infoMessages;
    }
    /**
     * Append the passed summary to this summary.
     * @param summary The summary to append to this.
     */
    Summary.prototype.append = function (summary) {
        Array.prototype.push.apply(this.errorMessages, summary.errorMessages);
        Array.prototype.push.apply(this.warningMessages, summary.warningMessages);
        Array.prototype.push.apply(this.infoMessages, summary.infoMessages);
        return this;
    };
    /**
     * Returns a new summary that is the concatenation of this and the passed summary.
     * @param summary The additional summary
     */
    Summary.prototype.concat = function (summary) {
        var errorMessages = this.errorMessages.concat(summary.errorMessages);
        var warningMessages = this.warningMessages.concat(summary.warningMessages);
        var infoMessages = this.infoMessages.concat(summary.infoMessages);
        return new Summary(errorMessages, warningMessages, infoMessages);
    };
    return Summary;
}());
exports.Summary = Summary;
var ResultSummary = (function () {
    function ResultSummary(data, summary) {
        if (data === void 0) { data = null; }
        if (summary === void 0) { summary = new Summary(); }
        this.data = data;
        this.summary = summary;
    }
    return ResultSummary;
}());
exports.ResultSummary = ResultSummary;
