"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/** Typecheck for ITable type */
function isITable(object) {
    return (object.name !== undefined
        && object.database !== undefined
        && object.columns !== undefined);
}
exports.isITable = isITable;
function isSqliteOrder(object) {
    object = local.gentleLowerCase(object);
    return (object === "asc"
        || object === "desc");
}
exports.isSqliteOrder = isSqliteOrder;
function isSqliteConstraintConflictResolution(object) {
    object = local.gentleLowerCase(object);
    return (object === "rollback"
        || object === "abort"
        || object === "fail"
        || object === "ignore"
        || object === "replace");
}
exports.isSqliteConstraintConflictResolution = isSqliteConstraintConflictResolution;
function isSqliteTriggerTime(object) {
    object = local.gentleLowerCase(object);
    return (object === "before"
        || object === "after"
        || object === "instead");
}
exports.isSqliteTriggerTime = isSqliteTriggerTime;
function isSqliteTriggerEvent(object) {
    object = local.gentleLowerCase(object);
    return (object === "delete"
        || object === "insert"
        || object === "update");
}
exports.isSqliteTriggerEvent = isSqliteTriggerEvent;
var local;
(function (local) {
    function gentleLowerCase(object) {
        try {
            return object.toLowerCase();
        }
        catch (e) {
            return object;
        }
    }
    local.gentleLowerCase = gentleLowerCase;
})(local || (local = {}));
